function updateVDModel(varargin)
    numOfVehicles = varargin{1};
    mode = varargin{2};
    cd E:\CoMoVe\CoMoVe_RL20210308\CoMoVe_RL\mathWorksFiles;
    basepath = cd+"\simulinkFiles\VDModel";
%     disp(basepath)
    
    % Update Project Reference Files
    updateProject("Driveline",basepath,numOfVehicles,mode);
    updateProject("PassVeh7DOF",basepath,numOfVehicles,mode);
    updateProject("PassVeh14DOF",basepath,numOfVehicles,mode);
    
    % Update main project file
    curpjt = openProject(basepath+"\main\VDModel.prj");
    basePos = get_param("VDReferenceApplication/VDModel","Position");
    x = basePos(1,1);
    y = basePos(1,2);
    offset = 100;
    
    for i=1:numOfVehicles
        pos = [x y+(i*offset) x+100 y+(i*offset)+50];
        path = "VDReferenceApplication/VDModel"+num2str(i);
        switch mode
            case 'add'
                add_block('VDReferenceApplication/VDModel', ...
                          'VDReferenceApplication/VDModel', ...
                          'MakeNameUnique','on', ...
                          'Position', pos);
                set_param(path+"/Passenger Vehicle/Steering, Transmission, Driveline and Brakes/Driveline Ideal Fixed Gear","ModelName","Driveline_"+num2str(i))            
                set_param(path+"/Passenger Vehicle/Body, Suspension, Wheels/PassVeh14DOF","ModelName","PassVeh14DOF_"+num2str(i))            
                set_param(path+"/Passenger Vehicle/Body, Suspension, Wheels/PassVeh7DOF","ModelName","PassVeh7DOF_"+num2str(i))            
            case 'delete'
                delete_block("VDReferenceApplication/VDModel"+num2str(i));
        end
    end

    switch mode
        case 'add'
            set_param("VDReferenceApplication/VDModel",'Commented','on')
        case 'delete'
            set_param("VDReferenceApplication/VDModel",'Commented','off')
            close(curpjt);
    end
    save_system("VDReferenceApplication");
    if mode == "delete"
        close_system("VDReferenceApplication");
    end
end
function updateProject(blockName,basepath,numOfVehicles,mode)
    pjtPath = "\refs\"+blockName+"\"+blockName+".prj";
    curpjt = openProject(basepath+pjtPath);
    for i=1:numOfVehicles
        switch mode
            case 'add'
                addFile(curpjt,cd+"\Plant\"+blockName+"_"+num2str(i)+".slx")
            case 'delete'
                removeFile(curpjt,cd+"\Plant\"+blockName+"_"+num2str(i)+".slx")
        end
    end
    reload(curpjt);
    close(curpjt);
end