function VEHICLES = vehInitialData_NEW_paper(varargin)
    numOfVehicles = varargin{1};
    vehData = varargin{2};
    VEHICLES = struct();    
    for i = 1:numOfVehicles
        curVehData = vehData((i*4)-4+1:4*i);
        VEHICLES.("VEH"+num2str(curVehData(4))) = struct();        
        VEHICLES.("VEH"+num2str(curVehData(4))).Mass = 1181;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalFrontLoad = struct;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalFrontLoad.FR = 264.66666666666669;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalFrontLoad.FL = 264.66666666666669;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalRearLoad = struct;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalRearLoad.RR = 322;
        VEHICLES.("VEH"+num2str(curVehData(4))).StaticNormalRearLoad.RL = 322;
        VEHICLES.("VEH"+num2str(curVehData(4))).WheelBase = 3.075;
        VEHICLES.("VEH"+num2str(curVehData(4))).FrontAxlePositionfromCG = 1.515;
        VEHICLES.("VEH"+num2str(curVehData(4))).RearAxlePositionfromCG = 1.504;
        VEHICLES.("VEH"+num2str(curVehData(4))).HeightCG = 0.134;
        VEHICLES.("VEH"+num2str(curVehData(4))).FrontalArea = 2.11;
        VEHICLES.("VEH"+num2str(curVehData(4))).DragCoefficient = 0.33;
        VEHICLES.("VEH"+num2str(curVehData(4))).NumberOfWheelsPerAxle = 2;
        VEHICLES.("VEH"+num2str(curVehData(4))).PitchMomentInertia = 1922.6666666666667;
        VEHICLES.("VEH"+num2str(curVehData(4))).RollMomentInertia = 432.33333333333331;
        VEHICLES.("VEH"+num2str(curVehData(4))).YawMomentInertia = 2066;
        VEHICLES.("VEH"+num2str(curVehData(4))).SteeringRatio = 18;
        VEHICLES.("VEH"+num2str(curVehData(4))).TrackWidth = 1.922;
        VEHICLES.("VEH"+num2str(curVehData(4))).SprungMass = 1096.7226666666666;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialLongPosition = curVehData(1);
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialLatPosition = curVehData(2);
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialVertPosition = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialRollAngle = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialPitchAngle = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialYawAngle = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialLongVel = curVehData(3);
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialLatVel = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialVertVel = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialRollRate = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialPitchRate = 0;
        VEHICLES.("VEH"+num2str(curVehData(4))).InitialYawRate = 0;      
        % suspension
        trackCoords = "[0 0;VEHICLES.VEH"+num2str(curVehData(4))+".TrackWidth*[-1 1]/2;0 0]";
        suspCoords = "[0 0;VEHICLES.VEH"+num2str(curVehData(4))+".TrackWidth*[-1 1]/2;0 0]";
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Suspension/Solid Axle Suspension Coil Spring", "TrackCoords", trackCoords);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Suspension/Solid Axle Suspension Coil Spring", "SuspCoords", suspCoords);
        % vehicles
        m = "VEHICLES.VEH"+num2str(curVehData(4))+".Mass";
        a = "VEHICLES.VEH"+num2str(curVehData(4))+".FrontAxlePositionfromCG";
        b = "VEHICLES.VEH"+num2str(curVehData(4))+".RearAxlePositionfromCG";
        h = "VEHICLES.VEH"+num2str(curVehData(4))+".HeightCG";
        Xe_o = "[VEHICLES.VEH"+num2str(curVehData(4))+".InitialLongPosition,VEHICLES.VEH"+num2str(curVehData(4))+".InitialLatPosition,VEHICLES.VEH"+num2str(curVehData(4))+".InitialVertPosition]";
        xbdot_o = "[VEHICLES.VEH"+num2str(curVehData(4))+".InitialLongVel,VEHICLES.VEH"+num2str(curVehData(4))+".InitialLatVel,VEHICLES.VEH"+num2str(curVehData(4))+".InitialVertVel]";
        eul_o =  "[VEHICLES.VEH"+num2str(curVehData(4))+".InitialRollAngle,VEHICLES.VEH"+num2str(curVehData(4))+".InitialPitchAngle,VEHICLES.VEH"+num2str(curVehData(4))+".InitialYawAngle]";
        p_o = "[VEHICLES.VEH"+num2str(curVehData(4))+".InitialRollRate,VEHICLES.VEH"+num2str(curVehData(4))+".InitialPitchRate,VEHICLES.VEH"+num2str(curVehData(4))+".InitialYawRate]";
        Iveh = "[VEHICLES.VEH"+num2str(curVehData(4))+".RollMomentInertia 0 0; 0 VEHICLES.VEH"+num2str(curVehData(4))+".PitchMomentInertia 0; 0 0 VEHICLES.VEH"+num2str(curVehData(4))+".YawMomentInertia]";
        width = "VEHICLES.VEH"+num2str(curVehData(4))+".TrackWidth.*[1 1]";
        Af = "VEHICLES.VEH"+num2str(curVehData(4))+".FrontalArea";
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "m", m);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "a", a);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "b", b);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "h", h);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "Xe_o", Xe_o);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "xbdot_o", xbdot_o);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "eul_o", eul_o);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "p_o", p_o);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "Iveh", Iveh);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "w", width);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Vehicle/Vehicle Body 6DOF", "Af", Af);
        % tires
        zo = ".015+VEHICLES.VEH"+num2str(curVehData(4))+".InitialVertPosition";
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Wheels and Tires/VDBS/Subsystem/Combined Slip Wheel 2DOF1", "zo", zo);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Wheels and Tires/VDBS/Subsystem/Combined Slip Wheel 2DOF2", "zo", zo);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Wheels and Tires/VDBS/Subsystem/Combined Slip Wheel 2DOF3", "zo", zo);
        set_param("vdbasemodel_paperCode/VDModel"+num2str(i)+"/Passenger Vehicle/Body/Wheels and Tires/VDBS/Subsystem/Combined Slip Wheel 2DOF4", "zo", zo);
    end
end

