function updateDetectionModel(varargin)
    vehIDs = varargin{1};
    carBuses = varargin{2};
    mode = varargin{3};
    offset = 100;    
    for i=1:size(vehIDs,2)
        curVehID = num2str(vehIDs(i));
        if mode == "add"            
            busName = carBuses.("car_"+curVehID);
            work_path = "objectDetectionModel/detectionModel_" + curVehID;
            add_block('built-in/Subsystem', work_path);
            set_param(work_path, 'Position', [835  offset 885 offset + 50]);
            Simulink.BlockDiagram.copyContentsToSubsystem('baseDetectionModel',work_path);
            set_param(work_path+"/out_radar",'VariableName', "radar_data_"+curVehID);
            set_param(work_path+"/out_camera",'VariableName', "camera_data_"+curVehID);
            set_param(work_path+"/Radar_Camera_Detections/scenario",'OutDataTypeStr', "Bus:"+busName);
            set_param(work_path+"/Radar_Camera_Detections/scenario",'Value', "car_"+curVehID);
            offset = offset + 100;
        elseif mode == "delete"
            delete_block("objectDetectionModel/detectionModel_" + curVehID);
        end
    end
    close_system('baseDetectionModel',0);
    save_system('objectDetectionModel');    
    if mode == "delete"
        close_system("objectDetectionModel");
    end
end

