import sys
import gym
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from newddpg import DDPGagent
from newutils import OUNoise, Randnormalnoise
import CoMoVe_RL_MultipleSteps_option2 as frmwrk
from tqdm import tqdm

if __name__ == "__main__":
    
    seed = 0
    np.random.seed(seed)
    
    env = frmwrk.SimulationEnvironment()
    
    batch_size = 32 #1; 2; 4; 8; 16; 32; 64; 128; 256
    droprob = 0 #0; 0.1; 0.2; 0.3; 0.4; 0.5
    l2penalty = 0 #0; 0.05; 0.1; 0.15; 0.2; 0.25; 0.3; 0.35; 0.4; 0.45; 0.5
    
    agent = DDPGagent(env, droprob, l2penalty)
    #ounoise = OUNoise(env.action_space)
    rdnoise = Randnormalnoise(env.action_space)
    
    rewards = []
    avg_rewards = []
    msg = []
    tot_info = []

    n_games = 1
    n_steps = 40 # n_steps*0.5s

    best_score = float('-inf')


    agent.load_models()
    for episode in range(n_games):
        state = env.reset()
        #ounoise.reset()
        episode_reward = 0
        
        for step in tqdm(range(n_steps)):
            action = agent.get_action(state)
            action = np.array([action])
            new_state, reward, done, info = env.startNextStep(action)
            agent.memory.push(state, action, reward, new_state, done)
            
            if episode == n_games - 1:
                tot_info.append(info)
                       
            
            state = new_state
            episode_reward += reward

            
            if done and env.zeroVelCounter >= 50:
                print("ending episode due to zero velocity")
                break

            elif done:
                print('Collision might happened, end game')
                break
            
        
        rewards.append(episode_reward)
        avg_score = np.mean(rewards[-50:])
        avg_rewards.append(avg_score)

    
        msg.append('episode {}, score {}, average score {}'.format(episode, round(episode_reward,4), round(avg_score,4)))
        print('episode {}, score {}, average score {}'.format(episode, round(episode_reward,4), round(avg_score,4)))

    
    # plt.plot(rewards)
    # plt.plot(avg_rewards)
    # plt.plot()
    # plt.xlabel('Episode')
    # plt.ylabel('Reward')
    # plt.show()
    
    env.stopSimulation("stop")
#%%
    # memory = np.array(agent.memory.buffer, dtype=object)
    # state_memory = memory[:,0]
    # action_memory = memory[:,1]
    # reward_memory = memory[:,2]
    # new_state_memory = memory[:,3]
    tot_info = np.array(tot_info, dtype = object)

    # np.save('state_memory.npy', state_memory)
    # np.save('action_memory.npy', action_memory)
    # np.save('new_state_memory.npy', new_state_memory)
    # np.save('reward_memory.npy', reward_memory)
    # np.save('msg_{}_dp{}_wd{}.npy'.format(batch_size, str(droprob).replace('.', 'x'), str(l2penalty).replace('.', 'x')), np.array(msg))
    # np.save('tot_info.npy', tot_info)
